<?php
/* * **************************************************************************************\
 * *   @name		EXP Autos  Pro                                                  **
 * *   @package          Joomla 1.6                                                      **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */

// No direct access to this file
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT . '/helpers/html');
JHtml::_('bootstrap.tooltip');
JHtml::_('behavior.multiselect');
JHtml::_('dropdown.init');
JHtml::_('formbehavior.chosen', 'select');

$user = JFactory::getUser();
$userId = $user->get('id');
$listOrder = $this->escape($this->state->get('list.ordering'));
$listDirn = $this->escape($this->state->get('list.direction'));
$makelist = $this->escape($this->state->get('filter.category_id'));
$canOrder = $user->authorise('core.edit.state', 'com_expautospro.expuser');
$archived = $this->state->get('filter.published') == 2 ? true : false;
$trashed = $this->state->get('filter.published') == -2 ? true : false;
$params = (isset($this->state->params)) ? $this->state->params : new JObject;
$saveOrder = $listOrder == 'ordering';
if ($saveOrder) {
    $saveOrderingUrl = 'index.php?option=com_expautospro&task=expusers.saveOrderAjax&tmpl=component';
    JHtml::_('sortablelist.sortable', 'expList', 'adminForm', strtolower($listDirn), $saveOrderingUrl);
}
$sortFields = $this->getSortFields();
?>
<!--
<script type="text/javascript">
    Joomla.orderTable = function() {
        table = document.getElementById("sortTable");
        direction = document.getElementById("directionTable");
        order = table.options[table.selectedIndex].value;
        if (order != '<?php echo $listOrder; ?>') {
            dirn = 'asc';
        } else {
            dirn = direction.options[direction.selectedIndex].value;
        }
        Joomla.tableOrdering(order, dirn, '');
    }
</script>
!-->
<form action="<?php echo JRoute::_('index.php?option=com_expautospro&view=expusers'); ?>" method="post" name="adminForm" id="adminForm">
    <div id="expfilter-bar" class="well well-small">
        <div class="input-append  pull-left">
            <label for="filter_search" class="element-invisible"><?php echo JText::_('JSEARCH_FILTER_LABEL'); ?></label>
            <input type="text" name="filter_search" id="filter_search" value="<?php echo $this->escape($this->state->get('filter.search')); ?>" title="<?php echo JText::_('COM_EXPAUTOSPRO_SEARCH_IN_NAME'); ?>"  placeholder="<?php echo JText::_('COM_EXPAUTOSPRO_ADM_SEACHCOMMA_TEXT'); ?>"/>
            <button type="submit" class="btn" title="<?php echo JText::_('JSEARCH_FILTER_SUBMIT'); ?>"><i class="icon-search"></i></button>
            <button type="button" class="btn" title="<?php echo JText::_('JSEARCH_FILTER_CLEAR'); ?>" onclick="document.id('filter_search').value='';this.form.submit();"><i class="icon-remove"></i></button>
        </div>
        <div class="btn-group pull-right">
            <select name="filter_language" class="inputbox input-medium" onchange="this.form.submit()">
                <option value=""><?php echo JText::_('JOPTION_SELECT_LANGUAGE'); ?></option>
                <?php echo JHtml::_('select.options', JHtml::_('contentlanguage.existing', true, true), 'value', 'text', $this->state->get('filter.language')); ?>
            </select>
        </div>
        <div class="btn-group pull-right">
            <select name="filter_state" class="inputbox input-medium" onchange="this.form.submit()">
                <option value=""><?php echo JText::_('JOPTION_SELECT_PUBLISHED'); ?></option>
                <?php echo JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->state->get('filter.state'), true); ?>
            </select>
        </div>
        <div class="btn-group pull-right">
            <select name="filter_positions" class="inputbox input-medium" onchange="this.form.submit()">
                <option value=""><?php echo JText::_('COM_EXPAUTOSPRO_ADMANAGERS_STATUS_SELECTPOSITIONS_TEXT'); ?></option>
                <?php echo $this->buildpositions; ?>
            </select>
        </div>
        <div class="btn-group pull-right">
            <select name="filter_group_id" class="inputbox input-medium" onchange="this.form.submit()">
                <option value=""><?php echo JText::_('COM_EXPAUTOSPRO_USERLEVEL_FILTER_USERGROUP'); ?></option>
                <?php echo JHtml::_('select.options', JFormFieldExpGroups::getOptions(), 'value', 'text', $this->state->get('filter.group_id')); ?>
            </select>
        </div>
    </div>
    <div class="clearfix"> </div>
    <table class="table table-bordered table-striped" id="expList">
        <thead>
            <tr>
                <th width="1%" class="nowrap center hidden-phone">
                    <?php echo JHtml::_('grid.sort', '<i class="icon-menu-2"></i>', 'ordering', $listDirn, $listOrder, null, 'asc', 'JGRID_HEADING_ORDERING'); ?>
                </th>
                <th width="1%" class="nowrap center">
                    <input type="checkbox" name="checkall-toggle" value="" title="<?php echo JText::_('JGLOBAL_CHECK_ALL'); ?>" onclick="Joomla.checkAll(this)" />
                </th>
                <th class="nowrap">
                    <?php echo JHtml::_('grid.sort', 'COM_EXPAUTOSPRO_USER_LASTNAME_TEXT', 'a.lastname', $listDirn, $listOrder); ?>
                </th>
                <th class="nowrap center">
                    <?php echo JHtml::_('grid.sort', 'COM_EXPAUTOSPRO_REP_NAME_TEXT', 'jname', $listDirn, $listOrder); ?>
                </th>
                <th class="nowrap center">
                    <?php echo JHtml::_('grid.sort', 'COM_EXPAUTOSPRO_USERNAME_TEXT', 'jusername', $listDirn, $listOrder); ?>
                </th>
                <th class="nowrap center" width="10%">
                    <?php echo JText::_('COM_EXPAUTOSPRO_USER_GROUPS_TEXT'); ?>
                </th>
                <th align="center" width="5%">
                    <?php echo JHtml::_('grid.sort', 'JPUBLISHED', 'state', $listDirn, $listOrder); ?>
                </th>
                <th class="nowrap center" width="5%">
                    <?php echo JHtml::_('grid.sort', 'COM_EXPAUTOSPRO_ADMANAGERS_STATUS_TOP_TEXT', 'a.utop', $listDirn, $listOrder, NULL, 'desc'); ?>
                </th>
                <th class="nowrap center" width="5%">
                    <?php echo JHtml::_('grid.sort', 'COM_EXPAUTOSPRO_ADMANAGERS_STATUS_COMMERCIAL_TEXT', 'a.ucommercial', $listDirn, $listOrder, NULL, 'desc'); ?>
                </th>
                <th class="nowrap center" width="5%">
                    <?php echo JHtml::_('grid.sort', 'COM_EXPAUTOSPRO_ADMANAGERS_STATUS_SPECIAL_TEXT', 'a.uspecial', $listDirn, $listOrder, NULL, 'desc'); ?>
                </th>
                <th class="nowrap center" width="5%">
                    <?php echo JHtml::_('grid.sort', 'JGRID_HEADING_LANGUAGE', 'a.language', $this->state->get('list.direction'), $this->state->get('list.ordering')); ?>
                </th>
                <th class="nowrap center" width="20">
                    <?php echo JHtml::_('grid.sort', 'JGRID_HEADING_ID', 'a.id', $listDirn, $listOrder); ?>
                </th>
            </tr>
        </thead>
        <tfoot>
            <tr>
                <td colspan="12">
                    <div class="clearfix"> </div>
                    <div class="btn-group pull-left hidden-phone">
                        <label for="limit" class="element-invisible"><?php echo JText::_('JFIELD_PLG_SEARCH_SEARCHLIMIT_DESC'); ?></label>
                        <?php echo $this->pagination->getLimitBox(); ?>
                    </div>
                    <div class="clearfix"> </div>
                </td>
            </tr>
        </tfoot>
        <tbody>
            <?php
            foreach ($this->items as $i => $item) :
                $ordering = ($listOrder == 'a.ordering');
                $canCreate = $user->authorise('core.create', 'com_expautospro.expuser.' . $item->id);
                $canEdit = $user->authorise('core.edit', 'com_expautospro.expuser.' . $item->id);
                $canCheckin = $user->authorise('core.manage', 'com_checkin') || $item->checked_out == $user->get('id') || $item->checked_out == 0;
                $canChange = $user->authorise('core.edit.state', 'com_expautospro.expuser.' . $item->id) && $canCheckin;
                $link = JRoute::_('index.php?option=com_expautospro&task=expuser.edit&id=' . $item->id);
                $userlink = JRoute::_('index.php?option=com_users&task=user.edit&id=' . $item->userid);
                //print_r($item);
                ?>
                <tr class="row<?php echo $i % 2; ?>">
                    <td class="order nowrap center hidden-phone">
                        <?php
                        if ($canChange) :
                            $disableClassName = '';
                            $disabledLabel = '';
                            if (!$saveOrder) :
                                $disabledLabel = JText::_('JORDERINGDISABLED');
                                $disableClassName = 'inactive tip-top';
                            endif;
                            ?>
                            <span class="sortable-handler hasTooltip <?php echo $disableClassName ?>" title="<?php echo $disabledLabel ?>">
                                <i class="icon-menu"></i>
                            </span>
                            <input type="text" style="display:none" name="order[]" size="5"
                                   value="<?php echo $item->ordering; ?>" class="width-20 text-area-order " />
                               <?php else : ?>
                            <span class="sortable-handler inactive" >
                                <i class="icon-menu"></i>
                            </span>
                        <?php endif; ?>
                    </td>
                    <td width="20">
                        <?php echo JHtml::_('grid.id', $i, $item->id); ?>
                    </td>
                    <td>
                        <span class="editlinktip hasTip" title="<?php echo JText::_('COM_EXPAUTOSPRO_USER_EDIT_TITLE'); ?>::<?php echo $this->escape($item->lastname); ?>">
                            <a href="<?php echo $link; ?>">
                                <?php echo $this->escape($item->lastname); ?>
                            </a>
                        </span>
                    </td>
                    <td class="center">
                        <?php echo $this->escape($item->jname); ?>
                    </td>
                    <td class="center">
                        <span class="editlinktip hasTip" title="<?php echo JText::_('COM_EXPAUTOSPRO_USERNAME_EDIT_TEXT'); ?>::<?php echo $this->escape($item->jusername); ?>">
                            <a href="<?php echo $userlink; ?>">
                                <?php echo $this->escape($item->jusername); ?>
                            </a>
                        </span>
                    </td>
                    <td class="center">
                        <?php echo nl2br($item->group_names); ?>
                    </td>
                    <td class="center">
                        <?php echo JHtml::_('jgrid.published', $item->state, $i, 'expusers.', $canChange, 'cb'); ?>
                    </td>
                    <td class="center">
                        <?php echo JHtml::_('jgrid.published', $item->utop, $i, 'expusers.utop_', $canChange); ?>
                    </td>
                    <td class="center">
                        <?php echo JHtml::_('jgrid.published', $item->ucommercial, $i, 'expusers.ucommercial_', $canChange); ?>
                    </td>
                    <td class="center">
                        <?php echo JHtml::_('jgrid.published', $item->uspecial, $i, 'expusers.uspecial_', $canChange); ?>
                    </td>
                    <td class="center nowrap">
                        <?php if ($item->language == '*'): ?>
                            <?php echo JText::alt('JALL', 'language'); ?>
                        <?php else: ?>
                            <?php echo $item->language_title ? $this->escape($item->language_title) : JText::_('JUNDEFINED'); ?>
                        <?php endif; ?>
                    </td>
                    <td class="center">
                        <?php echo $item->id; ?>
                    </td>
                </tr>
            <?php endforeach; ?>
        </tbody>
    </table>
    <div class="center">
        <?php echo $this->pagination->getListFooter(); ?>
    </div>
    <div>
        <input type="hidden" name="task" value="" />
        <input type="hidden" name="boxchecked" value="0" />
        <input type="hidden" name="filter_order" value="<?php echo $listOrder; ?>" />
        <input type="hidden" name="filter_order_Dir" value="<?php echo $listDirn; ?>" />
        <?php echo JHtml::_('form.token'); ?>
    </div>
</form>
