<?php

/* * **************************************************************************************\
 * *   @name		EXP Autos  Pro                                                  **
 * *   @package          Joomla 1.6                                                      **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */


defined('JPATH_BASE') or die;

jimport('joomla.html.html');
jimport('joomla.form.formfield');
jimport('joomla.form.helper');
require_once JPATH_SITE . '/components/com_expautospro/helpers/expparams.php';

class JFormFieldExpphoto extends JFormField {

    /**
     * The form field type.
     *
     * @var		string
     * @since	1.6
     */
    protected $type = 'Expphoto';

    /**
     * Method to get the field options.
     *
     * @return	array	The field option objects.
     * @since	1.6
     */
    public function getInput() {
        $expparams = ExpAutosProExpparams::getExpParams('config', 1);
        $expmobenable = $expparams->get('c_admanager_useradd_usemobile', 0);
        $mob_return = null;
        if ($expmobenable) {
            $mob_return = ExpAutosProExpparams::expmobile_detect();
        }
        $table_id = (int) $this->form->getValue('id');
        $result = ExpAutosProExpparams::getExpParams('expuser', $table_id);
        $result = $result->get('expphoto');
        if ($result) {
            $logoimg = '';
            if ($mob_return) {
                $logoimg .= '<li><img src="' . ExpAutosProExpparams::ImgUrlPatchLogo() . $result . '" />';
                $logoimg .='<label id="jform_delete_photo-lbl" for="jform_delete_photo">';
                $logoimg .='<input data-mini="true" id="expdeletephoto" type="checkbox" class="custom"name="delete_userphoto"/>';
                $logoimg .= JText::_('COM_EXPAUTOSPRO_CP_EXPUSER_DEALERINFO_DELETEPHOTO_TEXT');
                $logoimg .='</label></li>';
                $logoimg .= "<input type='hidden' name='userphoto_name' value='" . $result . "' />";
            } else {
                $logoimg .= '<li><img src="' . ExpAutosProExpparams::ImgUrlPatchLogo() . $result . '" /></li>';
                $logoimg .= '<li>';
                $logoimg .='<input type="checkbox" name="delete_userphoto"/>';
                $logoimg .='<label id="jform_delete_photo-lbl" for="jform_delete_photo" title="">';
                $logoimg .= JText::_('COM_EXPAUTOSPRO_CP_EXPUSER_DEALERINFO_DELETEPHOTO_TEXT');
                $logoimg .='</label>';
                $logoimg .= "</li>";
                $logoimg .= "<input type='hidden' name='userphoto_name' value='" . $result . "' />";
            }
        } else {
            $attr = $this->element['onchange'] ? ' onclick="' . (string) $this->element['onchange'] . '"' : '';
            $logoimg = '<li><input type="file" name="userphoto" value="" ' . $attr . ' /></li>';
        }
        return $logoimg;
    }

}