<?php

/* * **************************************************************************************\
 * *   @name		EXP Autos  Pro                                                  **
 * *   @package          Joomla 1.6                                                      **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2013  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */

//no direct access
defined('_JEXEC') or die;
require_once JPATH_ROOT . '/components/com_expautospro/helpers/expparams.php';
require_once JPATH_ROOT . '/components/com_expautospro/helpers/expfields.php';

class ModExpautosExport {

    public static function export_file() {
        $user = JFactory::getUser();
        $expreqfield = ExpAutosProExpparams::getExpDealersParams($user->id);
        if ($user->id && $expreqfield->get('g_expexport', 0)) {
            $expOption = JRequest::getVar('option', 0);
            $id = (int) JRequest::getInt('expval', 0);
            $expexportval = (string) JRequest::getString('exptask', 0);
            if ($expOption == 'com_expautospro' && $id && $expexportval) {
                $config = JFactory::getConfig();
                $tmp_dest = $config->get('tmp_path') . '/' . $expexportval . "_" . $id . '.zip';
                $db_value = ModExpautosExport::expautospro_db($id, $user->id);
                $db_imgvalue = ModExpautosExport::expautospro_dbimg($id, $user->id);
                if ($db_value && $db_value->equipment) {
                    $eq_val = explode(",", $db_value->equipment);
                    $db_eq = ModExpautosExport::expautospro_equipment($eq_val);
                    $db_eq = implode(",", $db_eq);
                }
                if ($expexportval == 'expautospro') {
                    if ($db_value) {
                        $expautos_xmlval = ModExpautosExport::expautospro_xml($db_value, $db_imgvalue, $db_eq);
                        $result = ModExpautosExport::create_zip($db_imgvalue, $tmp_dest, 'xml', $expautos_xmlval, $db_value->make_name, $expexportval . '_' . $id, true);
                        //print_r($expautos_xmlval);
                        //die();
                    }
                }
                if ($expexportval == 'autoscout') {
                    
                }
            }
        } else {
            return false;
        }
    }

    public static function expautospro_xml($db_value, $db_imgvalue = '', $db_eq = '') {
        $newsXML = new DOMDocument('1.0', 'UTF-8');
        $newsXML->formatOutput = true;
        $newsXML->preserveWhiteSpace = false;
        $expautospro = $newsXML->createElement("expautospro");
        $newsXML->appendChild($expautospro);
        $generaltag = $newsXML->createElement("general");
        $expautospro->appendChild($generaltag);
        $catid = $newsXML->createElement('catid', ModExpautosExport::expautospro_checkval($db_value->category_name));
        $make = $newsXML->createElement('make', ModExpautosExport::expautospro_checkval($db_value->make_name));
        $model = $newsXML->createElement('model', ModExpautosExport::expautospro_checkval($db_value->model_name));
        $specificmodel = $newsXML->createElement('specificmodel', ModExpautosExport::expautospro_checkval($db_value->specificmodel));
        $condition = $newsXML->createElement('condition', ModExpautosExport::expautospro_checkval($db_value->cond_name));
        $bodytype = $newsXML->createElement('bodytype', ModExpautosExport::expautospro_checkval($db_value->bodytype_name));
        $drive = $newsXML->createElement('drive', ModExpautosExport::expautospro_checkval($db_value->drive_name));
        $fuel = $newsXML->createElement('fuel', ModExpautosExport::expautospro_checkval($db_value->fuel_name));
        $trans = $newsXML->createElement('trans', ModExpautosExport::expautospro_checkval($db_value->trans_name));
        $specifictrans = $newsXML->createElement('specifictrans', ModExpautosExport::expautospro_checkval($db_value->specifictrans));
        $extcolor = $newsXML->createElement('extcolor', ModExpautosExport::expautospro_checkval($db_value->extcolor_name));
        $intcolor = $newsXML->createElement('intcolor', ModExpautosExport::expautospro_checkval($db_value->intcolor_name));
        $doors = $newsXML->createElement('doors', ModExpautosExport::expautospro_checkval($db_value->doors));
        $seats = $newsXML->createElement('seats', ModExpautosExport::expautospro_checkval($db_value->seats));
        $engine = $newsXML->createElement('engine', ModExpautosExport::expautospro_checkval($db_value->engine));
        $displacement = $newsXML->createElement('displacement', ModExpautosExport::expautospro_checkval($db_value->displacement));
        $metalliccolor = $newsXML->createElement('metalliccolor', ModExpautosExport::expautospro_checkval($db_value->metalliccolor));
        $specificcolor = $newsXML->createElement('specificcolor', ModExpautosExport::expautospro_checkval($db_value->specificcolor));
        $fconsumcity = $newsXML->createElement('fconsumcity', ModExpautosExport::expautospro_checkval($db_value->fconsumcity));
        $fconsumfreeway = $newsXML->createElement('fconsumfreeway', ModExpautosExport::expautospro_checkval($db_value->fconsumfreeway));
        $fconsumcombined = $newsXML->createElement('fconsumcombined', ModExpautosExport::expautospro_checkval($db_value->fconsumcombined));
        $adacceleration = $newsXML->createElement('adacceleration', ModExpautosExport::expautospro_checkval($db_value->adacceleration));
        $maxspeed = $newsXML->createElement('maxspeed', ModExpautosExport::expautospro_checkval($db_value->maxspeed));
        $co = $newsXML->createElement('co', ModExpautosExport::expautospro_checkval($db_value->co));
        if ($db_eq) {
            $equipment = $newsXML->createElement('equipment', ModExpautosExport::expautospro_checkval($db_eq));
        }
        $year = $newsXML->createElement('year', ModExpautosExport::expautospro_checkval($db_value->year));
        $month = $newsXML->createElement('month', ModExpautosExport::expautospro_checkval($db_value->month));
        $vincode = $newsXML->createElement('vincode', ModExpautosExport::expautospro_checkval($db_value->vincode));
        $mileage = $newsXML->createElement('mileage', ModExpautosExport::expautospro_checkval($db_value->mileage));
        $price = $newsXML->createElement('price', ModExpautosExport::expautospro_checkval($db_value->price));
        $bprice = $newsXML->createElement('bprice', ModExpautosExport::expautospro_checkval($db_value->bprice));
        $expprice = $newsXML->createElement('expprice', ModExpautosExport::expautospro_checkval($db_value->expprice));
        $vattext = $newsXML->createElement('vattext', ModExpautosExport::expautospro_checkval($db_value->vattext));
        $embedcode = $newsXML->createElement('embedcode');
        $embedcodechild = $newsXML->createCDATASection(ModExpautosExport::expautospro_checkval($db_value->embedcode));
        $otherinfo = $newsXML->createElement('otherinfo');
        $otherinfochild = $newsXML->createCDATASection(ModExpautosExport::expautospro_checkval($db_value->otherinfo));
        $ef1 = $newsXML->createElement('extrafield1', ModExpautosExport::expautospro_checkval($db_value->ef1_name));
        $ef2 = $newsXML->createElement('extrafield2', ModExpautosExport::expautospro_checkval($db_value->ef2_name));
        $ef3 = $newsXML->createElement('extrafield3', ModExpautosExport::expautospro_checkval($db_value->ef3_name));
        $stocknum = $newsXML->createElement('stocknum', ModExpautosExport::expautospro_checkval($db_value->stocknum));
        $country = $newsXML->createElement('country', ModExpautosExport::expautospro_checkval($db_value->cnt_name));
        $expstate = $newsXML->createElement('expstate', ModExpautosExport::expautospro_checkval($db_value->st_name));
        $city = $newsXML->createElement('city', ModExpautosExport::expautospro_checkval($db_value->ct_name));
        $street = $newsXML->createElement('street', ModExpautosExport::expautospro_checkval($db_value->street));
        $latitude = $newsXML->createElement('latitude', ModExpautosExport::expautospro_checkval($db_value->latitude));
        $longitude = $newsXML->createElement('longitude', ModExpautosExport::expautospro_checkval($db_value->longitude));
        $zipcode = $newsXML->createElement('zipcode', ModExpautosExport::expautospro_checkval($db_value->zipcode));
        $unweight = $newsXML->createElement('unweight', ModExpautosExport::expautospro_checkval($db_value->unweight));
        $grweight = $newsXML->createElement('grweight', ModExpautosExport::expautospro_checkval($db_value->grweight));
        $length = $newsXML->createElement('length', ModExpautosExport::expautospro_checkval($db_value->length));
        $width = $newsXML->createElement('width', ModExpautosExport::expautospro_checkval($db_value->width));

        $generaltag->appendChild($catid);
        $generaltag->appendChild($make);
        $generaltag->appendChild($model);
        $generaltag->appendChild($specificmodel);
        $generaltag->appendChild($condition);
        $generaltag->appendChild($bodytype);
        $generaltag->appendChild($drive);
        $generaltag->appendChild($fuel);
        $generaltag->appendChild($trans);
        $generaltag->appendChild($specifictrans);
        $generaltag->appendChild($extcolor);
        $generaltag->appendChild($intcolor);
        $generaltag->appendChild($doors);
        $generaltag->appendChild($seats);
        $generaltag->appendChild($engine);
        $generaltag->appendChild($displacement);
        $generaltag->appendChild($metalliccolor);
        $generaltag->appendChild($specificcolor);
        $generaltag->appendChild($fconsumcity);
        $generaltag->appendChild($fconsumfreeway);
        $generaltag->appendChild($fconsumcombined);
        $generaltag->appendChild($adacceleration);
        $generaltag->appendChild($maxspeed);
        $generaltag->appendChild($co);
        if ($db_eq) {
            $generaltag->appendChild($equipment);
        }
        $generaltag->appendChild($year);
        $generaltag->appendChild($month);
        $generaltag->appendChild($vincode);
        $generaltag->appendChild($mileage);
        $generaltag->appendChild($price);
        $generaltag->appendChild($bprice);
        $generaltag->appendChild($expprice);
        $generaltag->appendChild($vattext);
        $embedcode->appendChild($embedcodechild);
        $generaltag->appendChild($embedcode);
        $otherinfo->appendChild($otherinfochild);
        $generaltag->appendChild($otherinfo);
        $generaltag->appendChild($ef1);
        $generaltag->appendChild($ef2);
        $generaltag->appendChild($ef3);
        $generaltag->appendChild($stocknum);
        $generaltag->appendChild($country);
        $generaltag->appendChild($expstate);
        $generaltag->appendChild($city);
        $generaltag->appendChild($street);
        $generaltag->appendChild($latitude);
        $generaltag->appendChild($longitude);
        $generaltag->appendChild($zipcode);
        $generaltag->appendChild($unweight);
        $generaltag->appendChild($grweight);
        $generaltag->appendChild($length);
        $generaltag->appendChild($width);

        if ($db_imgvalue) {
            $images = $newsXML->createElement("images");
            $generaltag->appendChild($images);
            $cnt_img = count($db_imgvalue);
            $i = 0;
            foreach ($db_imgvalue as $imgval) {
                $i++;
                if ($imgval['imgordering']) {
                    $ord = $imgval['imgordering'];
                } else {
                    $ord = $i;
                }
                $img = $newsXML->createElement("img");
                $imgname = $newsXML->createElement("name", $db_value->make_name . "_" . $ord . ".jpg");
                $imgordering = $newsXML->createElement("ordering", $imgval['imgordering']);
                $imgdescription = $newsXML->createElement("description");
                $imgdescriptionchild = $newsXML->createCDATASection($imgval['imgdescription']);
                $images->appendChild($img);
                $img->appendChild($imgname);
                $img->appendChild($imgordering);
                $imgdescription->appendChild($imgdescriptionchild);
                $img->appendChild($imgdescription);
            }
        }
        return $newsXML->saveXML();
    }

    public static function expautospro_checkval($value) {
        if (!$value) {
            $value = 0;
        }
        return $value;
    }

    public static function expautospro_dbimg($id, $userid) {
        $checkad = ExpAutosProFields::expaddcheck($id, $userid);
        $expedit = false;
        if ((int) $id) {
            $userad = ExpAutosProExpparams::expaddcheckuser($id);
            $groupparams2 = ExpAutosProExpparams::expGroupsEdit((int) $userad);
            if ($groupparams2) {
                $expedit = true;
            }
        }
        $return = null;
        if ($checkad || $expedit) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);

            $query->select('a.name as imgname,a.ordering as imgordering,a.description as imgdescription');
            $query->from('#__expautos_images as a');
            $query->where('a.state=1');
            $query->where('a.catid=' . (int) $id);
            $db->setQuery((string) $query);

            if (!$db->query()) {
                JError::raiseError(500, $db->getErrorMsg());
            }

            $return = $db->loadAssocList();
        } else {
            $msg = JText::_('COM_EXPAUTOSPRO_IMPORTXML_ERROR_CHECKAD_TEXT');
            JError::raiseError(500, $msg);
            return false;
        }
        return $return;
    }

    public static function expautospro_equipment($eq) {
        foreach ($eq as $value) {
            $db = JFactory::getDBO();
            $query = $db->getQuery(true);
            $query->select('name');
            $query->from('#__expautos_equipment');
            $query->where('state=1');
            $query->where('id IN(' . $value . ')');
            $query->order('ordering');
            $db->setQuery($query);
            $equipmentn[] = $db->loadResult();
        }
        return $equipmentn;
    }

    public static function expautospro_db($id, $userid) {
        $checkad = ExpAutosProFields::expaddcheck($id, $userid);
        $expedit = false;
        if ((int) $id) {
            $userad = ExpAutosProExpparams::expaddcheckuser($id);
            $groupparams2 = ExpAutosProExpparams::expGroupsEdit((int) $userad);
            if ($groupparams2) {
                $expedit = true;
            }
        }
        $return = null;
        if ($checkad || $expedit) {
            $db = JFactory::getDbo();
            $query = $db->getQuery(true);

            $query->select('a.*');
            $query->from('#__expautos_admanager as a');
            $query->where('a.state IN (0,1)');
            $query->where('a.id=' . (int) $id);

            $query->select('c.title AS category_name, c.id AS categid');
            $query->join('LEFT', '#__categories AS c ON c.id = a.catid');

            /* Makes */
            $query->select('mk.id AS mkid,mk.name AS make_name');
            $query->join('LEFT', '#__expautos_make AS mk ON mk.id = a.make');
            //$query->where('mk.state=1');

            /* Models */
            $query->select('md.id AS mdid,md.name AS model_name');
            $query->join('LEFT', '#__expautos_model AS md ON md.id = a.model');

            /* Body Type */
            $query->select('bt.id AS btid,bt.name AS bodytype_name');
            $query->join('LEFT', '#__expautos_bodytype AS bt ON bt.id = a.bodytype');

            /* Drive */
            $query->select('dr.id AS drid,dr.name AS drive_name');
            $query->join('LEFT', '#__expautos_drive AS dr ON dr.id = a.drive');

            /* Ext Color */
            $query->select('ecl.id AS eclid,ecl.name AS extcolor_name, ecl.image AS extcolor_image');
            $query->join('LEFT', '#__expautos_color AS ecl ON ecl.id = a.extcolor');

            /* Transmission */
            $query->select('tr.id AS trid,tr.name AS trans_name, tr.code AS trans_code');
            $query->join('LEFT', '#__expautos_trans AS tr ON tr.id = a.trans');

            /* Fuel */
            $query->select('fl.id AS flid,fl.name AS fuel_name, fl.code AS fuel_code');
            $query->join('LEFT', '#__expautos_fuel AS fl ON fl.id = a.fuel');

            /* Condition */
            $query->select('cond.id AS condid,cond.name AS cond_name');
            $query->join('LEFT', '#__expautos_condition AS cond ON cond.id = a.condition');

            /* User 
              $query->select('user.id AS userwid,user.name AS user_name, user.username AS user_username, user.email AS user_email');
              $query->join('LEFT', '#__users AS user ON user.id = a.user');
             */

            // Country Vehicle
            $query->select('cnt.id AS cntid,cnt.name AS cnt_name');
            $query->join('LEFT', '#__expautos_country AS cnt ON cnt.id = a.country');

            // State Vehicle
            $query->select('st.id AS stid,st.name AS st_name');
            $query->join('LEFT', '#__expautos_state AS st ON st.id = a.expstate');

            // City Vehicle
            $query->select('ct.id AS ctid,ct.city_name AS ct_name');
            $query->join('LEFT', '#__expautos_cities AS ct ON ct.id = a.city');

            // Int Color
            $query->select('inter.id AS interid,inter.name AS intcolor_name, inter.image AS intcolor_image');
            $query->join('LEFT', '#__expautos_color AS inter ON inter.id = a.intcolor');

            // Extra Field 1
            $query->select('ef1.id AS ef1id,ef1.name AS ef1_name');
            $query->join('LEFT', '#__expautos_extrafield1 AS ef1 ON ef1.id = a.extrafield1');

            // Extra Field 2
            $query->select('ef2.id AS ef2id,ef2.name AS ef2_name');
            $query->join('LEFT', '#__expautos_extrafield2 AS ef2 ON ef2.id = a.extrafield2');

            // Extra Field 3
            $query->select('ef3.id AS ef3id,ef3.name AS ef3_name');
            $query->join('LEFT', '#__expautos_extrafield3 AS ef3 ON ef3.id = a.extrafield3');


            $db->setQuery((string) $query);

            if (!$db->query()) {
                JError::raiseError(500, $db->getErrorMsg());
            }

            $return = $db->loadObject();
        } else {
            $msg = JText::_('COM_EXPAUTOSPRO_IMPORTXML_ERROR_CHECKAD_TEXT');
            JError::raiseError(500, $msg);
            return false;
        }
        return $return;
    }

    public static function create_zip($files = array(), $destination = '', $fileext = 'xml', $filetext = '', $imgname = 'autos', $archivename = 'expautospro', $overwrite = false) {
        if (file_exists($destination) && !$overwrite) {
            return false;
        }
        $valid_files = array();
        if (is_array($files)) {
            foreach ($files as $file) {
                if (file_exists(ExpAutosProExpparams::ImgAbsPathBig() . $file['imgname'])) {
                    $valid_files[$file['imgordering']] = ExpAutosProExpparams::ImgAbsPathBig() . $file['imgname'];
                }
            }
        }
        $zip = new ZipArchive();
        if ($zip->open($destination, $overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) {
            return false;
        }
        if (count($valid_files)) {
            foreach ($valid_files as $key => $file) {
                $zip->addFile($file, basename($file));
                $zip->renameName(basename($file), $imgname . "_" . $key . '.jpg');
            }
        }
        $zip->addFromString($archivename . '.' . $fileext, $filetext);
        $zip->close();
        ob_end_clean();
        header('Content-type: application/zip');
        header('Content-Disposition: attachment; filename="' . $archivename . '.zip"');
        ob_clean();
        flush();
        readfile($destination);
        unlink($destination);
        exit();
    }

}
?>

