<?php
/* * **************************************************************************************\
 * *   @name		EXP Login                                                       **
 * *   @package          Joomla 1.6/1.7/2.5                                              **
 * *   @author		EXP TEAM::Alexey Kurguz (Grusha)                                **
 * *   @copyright	Copyright (C) 2005 - 2012  EXP TEAM::Alexey Kurguz (Grusha)     **
 * *   @link             http://www.feellove.eu                                          **
 * *   @license		Commercial License                                              **
  \*************************************************************************************** */

// no direct access
defined('_JEXEC') or die;
JHtml::_('behavior.keepalive');

$document = JFactory::getDocument();
$document->addStyleSheet(JURI::root() . 'modules/mod_explogin/css/mod_explogin_button.css');
?>

<?php if ($type == 'logout') : ?>
    <ul class="explogout_ul <?php echo $moduleclass_sfx; ?>" id="explogin_logout">
        <li>
            <form action="<?php echo JRoute::_('index.php', true, $params->get('usesecure')); ?>" method="post" id="login-form" class="explogin_form">
                <button type="submit" name="Submit" class="button btn btn-small btn-warning" value="<?php echo JText::_('JLOGOUT'); ?>" /><i class="icon-user"></i> <?php echo JText::_('JLOGOUT'); ?></button>
                <input type="hidden" name="option" value="com_users" />
                <input type="hidden" name="task" value="user.logout" />
                <input type="hidden" name="return" value="<?php echo $return; ?>" />
                <?php echo JHtml::_('form.token'); ?>
            </form>
        </li>
    </ul>
<?php else : ?>

    <ul class="btn-group pull-right">
        <button data-toggle="dropdown" class="btn btn-small btn-primary dropdown-toggle">
            <i class="icon-user icon-white"></i> 
            <?php
            if ($type == 'logout') {
                echo JText::_('JLOGOUT');
            } else {
                echo JText::_('JLOGIN');
            }
            ?>
            <span class="caret"></span></button>
        <ul class="dropdown-menu explogin_drop">
            <li class="explogin_drop_li">
                <form action="<?php echo JRoute::_('index.php', true, $params->get('usesecure')); ?>" method="post" id="login-form" >
                    <?php if ($params->get('pretext')): ?>
                        <div class="explogin_text <?php echo $params->get('pretext_class'); ?>">
                            <p><?php echo $params->get('pretext'); ?></p>
                        </div>
                    <?php endif; ?>
                    <fieldset class="userdata">
                        <div class="control-group">
                            <label for="modlgn-username"><?php echo JText::_('MOD_EXPLOGIN_VALUE_USERNAME') ?></label>
                            <div class="controls">
                                <div class="input-prepend">
                                    <span class="add-on"><i class="icon-user"></i></span>
                                    <input class="span2" id="modlgn-username" type="text" name="username" class="inputbox" />
                                </div>
                            </div>
                        </div>
                        <div class="control-group">
                            <label for="modlgn-passwd"><?php echo JText::_('JGLOBAL_PASSWORD') ?></label>
                            <div class="controls">
                                <div class="input-prepend">
                                    <span class="add-on"><i class="icon-lock"></i></span>
                                    <input class="span2" id="modlgn-passwd" type="password" name="password" class="inputbox" />
                                </div>
                            </div>
                        </div>
                        <?php if (JPluginHelper::isEnabled('system', 'remember')) : ?>
                            <label for="modlgn-remember" class="checkbox">
                                <input id="modlgn-remember" type="checkbox" name="remember" class="inputbox" value="yes"/><?php echo JText::_('MOD_EXPLOGIN_REMEMBER_ME') ?>
                            </label>
                        <?php endif; ?>

                        <button type="submit" name="Submit" class="button button btn btn-primary" ><i class="icon-check icon-white"></i> <?php echo JText::_('JLOGIN') ?></button>
                        <input type="hidden" name="option" value="com_users" />
                        <input type="hidden" name="task" value="user.login" />
                        <input type="hidden" name="return" value="<?php echo $return; ?>" />
                        <?php echo JHtml::_('form.token'); ?>
                    </fieldset>
                    <ul class="explogin_link">
                        <li>
                            <a href="<?php echo JRoute::_('index.php?option=com_users&view=reset'); ?>">
                                <i class="icon-lock"></i> <?php echo JText::_('MOD_EXPLOGIN_FORGOT_YOUR_PASSWORD'); ?>
                            </a>
                        </li>
                        <li>
                            <a href="<?php echo JRoute::_('index.php?option=com_users&view=remind'); ?>">
                                <i class="icon-user"></i> <?php echo JText::_('MOD_EXPLOGIN_FORGOT_YOUR_USERNAME'); ?>
                            </a>
                        </li>
                        <?php
                        $usersConfig = JComponentHelper::getParams('com_users');
                        if ($usersConfig->get('allowUserRegistration')) :
                            ?>
                            <li>
                                <a href="<?php echo JRoute::_('index.php?option=com_users&view=registration'); ?>">
                                    <i class="icon-plus-sign"></i> <?php echo JText::_('MOD_EXPLOGIN_REGISTER'); ?>
                                </a>
                            </li>
                        <?php endif; ?>
                    </ul>
                    <?php if ($params->get('posttext')): ?>
                        <div class="explogin_text <?php echo $params->get('posttext_class'); ?>">
                            <p><?php echo $params->get('posttext'); ?></p>
                        </div>
                    <?php endif; ?>
                </form> 

            </li>
        </ul>
    </ul>
<script>
    jQuery('.explogin_drop form').on('click', function (e) {
  e.stopPropagation()
})
</script>
<?php endif; ?>
